# ================================================================================== #
# === cSTATS - Ranks & Statistics Modification for Counter-Strike:Source Servers === #
# === -------------------------------------------------------------------------- === #
# ================================================================================== #
import sys
import es
import playerlib
import MySQLdb
import popuplib

# ================================================================================== #
# ==========  G l o b a l   C o n f i g u r a t i o n  V a r i a b l e s  ========== #
# ================================================================================== #
# Modify the variables below to your needs...

# === General Settings === #
cs_include_bots 		= 1				# Include bots with statistics?

# ==== MySQL Settings ==== #
cs_mysql_hostname		= '10.0.1.9'	# Server / Hostname for the mysql server (webserver)
cs_mysql_username		= 'root'		# Username, needed to login on the sql server
cs_mysql_password		= 'd2648M'		# Password, also needed to login on the sql server
cs_mysql_database		= 'cstrike'		# Database - Where you want the data to be stored.

# ==== Stats Settings ==== #
cs_stats_multiplier		= 2				# Multiply gained points from a frag (Default:2)
cs_stats_maxpoints		= 40			# Set a max points (security reason) (Default:30)
cs_stats_headshotbonus	= 3				# Bonus points for headshots (p = (((pv/pa)*mul)*pw_mod)+hsbonus)
cs_stats_teamkill_loss	= 5				# Amount of points the attacker loses for a teamkill

cs_points_team_t_elim	= 5				# Team Points for Eliminating All Terrorists
cs_points_team_ct_elim	= 5				# Team Points for Eliminating All Counter-Terrorists
cs_points_team_bomb_bt	= 5				# Team Points for Bombing The Target
cs_points_team_bomb_d	= 5				# Team Points for Defusing the Bomb
cs_points_team_hostage_r= 5				# Team Points for All Hostages Rescued
cs_points_team_hostage_k= 2				# Team Points for Hostages Not Rescued

cs_points_bomb_planted  = 10			# Player points for Planting The Bomb
cs_points_bomb_defused  = 10			# Player points for Defusing The Bomb
cs_points_hostage_resc	= 5				# Player points for rescuing a hostage
cs_points_hostage_kill	= 3				# Player points penalty for killing a hostage

# Weapon Bonuses ( Base Points * WeaponBonus )
cs_bonus_weapon_glock			= 2
cs_bonus_weapon_usp				= 2
cs_bonus_weapon_p228			= 2
cs_bonus_weapon_deagle			= 2
cs_bonus_weapon_fiveseven		= 2
cs_bonus_weapon_elite			= 2
cs_bonus_weapon_m3				= 1
cs_bonus_weapon_xm1014			= 1
cs_bonus_weapon_tmp				= 1
cs_bonus_weapon_mac10			= 1
cs_bonus_weapon_mp5navy			= 1
cs_bonus_weapon_ump45			= 1
cs_bonus_weapon_p90				= 1
cs_bonus_weapon_famas			= 1
cs_bonus_weapon_galil			= 1
cs_bonus_weapon_ak47			= 1
cs_bonus_weapon_scout			= 2
cs_bonus_weapon_m4a1			= 1
cs_bonus_weapon_sg550			= 1
cs_bonus_weapon_g3sg1			= 1
cs_bonus_weapon_awp				= 0.5
cs_bonus_weapon_sg552			= 1
cs_bonus_weapon_aug				= 1
cs_bonus_weapon_m249			= 1
cs_bonus_weapon_hegrenade		= 4
cs_bonus_weapon_flashbang		= 1
cs_bonus_weapon_smokegrenade 	= 1
cs_bonus_weapon_knife			= 7

# ==== Language Vars ==== #
cs_txt_objective_ct_eliminated		= '#Green All Counter-Terrorists Eliminated'
cs_txt_objective_t_eliminated		= '#Green All Terrorists Eliminated'
cs_txt_objective_target_bombed		= '#Green Target Bombed'
cs_txt_objective_bomb_planted		= 'Planting the Bomb'
cs_txt_objective_bomb_defused2		= 'Defusing the Bomb'
cs_txt_objective_bomb_defused		= '#Green Defusing the Bomb'
cs_txt_objective_hostage_killed		= '#Green Killing a Hostage'
cs_txt_objective_hostage_r			= '#Green All Hostages Rescued'
cs_txt_objective_hostage_nr			= '#Green Hostages Not Rescued'
cs_txt_objective_hostage_resc		= 'Rescuing a Hostage'
cs_txt_objective_hostage_kill		= 'Killing a Hostage'
# --- Do NOT modify below this line --- #
sql_c = ''
info = es.AddonInfo() 
info.name = 'menz.Ranks & Statistics' 
info.basename = 'cstats' 
# ================================================================================== #
# ===============  M a i n   M o d u l e   A d d o n   S o u r c e  ================ #
# ================================================================================== #
def load():
	cst.init()

def player_say(e):
	chatcmd 	= e['text']
	userid 		= e['userid']
	steamidx 	= es.getplayersteamid(userid)
	name 		= es.getplayername(userid)	
	steamid		= cst.getSteamId(steamidx, name)
	
	# === PLACE === #
	if(chatcmd == 'place'):
		data 	= stats.getData(steamid)
		rank 	= data[2]
		points	= data[4]
		total 	= stats.getTotalRanks()
		es.msg( str(name) + ' is on place ' + str(rank) + ' of ' + str(total) + ' with ' + str(points) + ' points.')
		
	
	# === RANK / SESSION / KPD / STATSME === #
	if(chatcmd == 'rank'):
		showrank(userid)
	if(chatcmd == 'session'):
		showrank(userid)
	if(chatcmd == 'statsme'):
		showrank(userid)
	if(chatcmd == 'kpd'):
		showrank(userid)
	
	# === TOP 10 === #
	if(chatcmd == 'top10'):
		showtop10(userid)
		
	if(chatcmd == 'next'):
		shownext(userid)
		
def shownext(userid):
	global sql_c
	q 		= sql_c.cursor()
	stats.syncRankTable()
	steamid = es.getplayersteamid(userid)
	nextpopup = popuplib.create('nextpopup')
	nextpopup.addline('->1 - Next Players')
	nextpopup.addline('-------------------------------')
	mypoints = stats.getPoints(steamid)
	q.execute('SELECT * FROM stats ORDER BY rank DESC')
	n 	= int(q.rowcount)
	id 	= 0
	this_id = 0
	showit = 0
	for x in range(0,n):
		id 		= id + 1
		data	= q.fetchone()
		if(data[0] == steamid):
			showit = 1
			this_id = id
		
		if(id > this_id+20):
			showit = 0
			
		if(showit == 1):
			points = data[4]
			t = data[2]
			px = points - mypoints
			if(px > -1):
				pt = '+' + str(px)
			else:
				pt = str(px)
			pts = str(points) + ' (' + str(pt) + ')'
			nextpopup.addline(str(t)+'. '+str(data[1])+' - '+str(pts)+'')
	
	nextpopup.addline('-------------------------------')
	nextpopup.addline('->0 - Close.')
	nextpopup.send(userid)
	showit = 0
	
def showtop10(userid):
	global sql_c
	q 		= sql_c.cursor()
	steamid = es.getplayersteamid(userid)
	name 	= es.getplayername(userid)
	stats.syncRankTable()
	top10popup = popuplib.create('top10_popup')
	top10popup.addline('->1 - Top Players')
	top10popup.addline('-------------------------------')
	q.execute('SELECT * FROM stats ORDER BY rank ASC LIMIT 10')
	numrows = int(q.rowcount)
	for x in range(0, numrows):
		t = x + 1
		if(t < 10): 
			posr = '0' + str(t)
		else:
			posr = '10'
		
		c = q.fetchone()
		name = c[1]
		pts = c[4]
		top10popup.addline(str(posr)+' '+str(name)+' ('+str(pts)+')')
	
	top10popup.addline('-------------------------------')
	top10popup.send(userid)
	
def showrank(userid):
	global rankPopup
	stats.syncRankTable()
	steamidx 		= es.getplayersteamid(userid)
	name 			= es.getplayername(userid)
	steamid			= cst.getSteamId(steamidx, name)
	total_rank 		= stats.getTotalRanks()
	data 			= stats.getData(steamid)
	rank			= data[2]
	rank_old		= data[3]
	points 			= data[4]
	points_old		= data[5]
	kills			= data[6]
	kills_old		= data[7]
	deaths			= data[8]
	deaths_old		= data[9]
	headshots		= data[10]
	headshots_old 	= data[11]
	bombs_planted	= data[12]
	bombs_defused	= data[13]
	hostages_rescued= data[14]
	hostages_killed = data[15]
	suicides		= data[16]
	teamkills		= data[17]
	
	# Headshot Percentage for Total Ranking #
	try:
		hp = float (100 / float(kills))
		hpc = int( float(hp) * float(headshots))
	except:
		hpc = '0'
	
	
	# Session Data Calculations #
	skillchange = points - points_old
	if(skillchange > 0):
		sk = '+' + str(skillchange)
	else:
		sk = str(skillchange)
	headshot = headshots - headshots_old
	if(headshot > 0):
		hs = '+' + str(headshot)
	else:
		hs = str(headshot)
	rankchange = rank_old - rank
	if(rankchange > 0):
		rc = '+' + str(rankchange)
	else:
		rc = str(rankchange)
	
	
	rankPopup = popuplib.create('rank_popup')
	rankPopup.addline('->1 - Total Ranking')
	rankPopup.addline('      Position ' + str(rank) + ' of ' + str(total_rank))
	rankPopup.addline('      ' + str(points) + ' Points')
	rankPopup.addline('      ' + str(kills) + ':' + str(deaths) + ' Frags')
	rankPopup.addline('      ' + str(headshots) + ' (' + str(hpc) + '%) Headshots')
	rankPopup.addline('  ')
	rankPopup.addline('->2 - This Session')
	rankPopup.addline('    ' + str(sk) + ' Points')
	rankPopup.addline('    ' + str(rc) + ' Positions')
	rankPopup.addline('    ' + str(hs) + ' Headshots')
	rankPopup.addline('  ')
	rankPopup.addline('->3 - Achievements')
	rankPopup.addline('    ' + str(teamkills) + ' Teamkills')
	rankPopup.addline('    ' + str(suicides) + ' Suicides')
	rankPopup.addline('    ' + str(bombs_planted) + ' Bombs Planted')
	rankPopup.addline('    ' + str(bombs_defused) + ' Bombs Defused')
	rankPopup.addline('    ' + str(hostages_rescued) + ' Hostages Rescued')
	rankPopup.addline('    ' + str(hostages_killed) + ' Hostages Killed')
	rankPopup.addline('  ')
	rankPopup.send(userid)
	
def player_activate(e):
	instance_steamid 	= e['es_steamid']
	instance_alias		= e['es_username']
	steamid 			= cst.getSteamId(instance_steamid, instance_alias)
	if(cst.botCheck(instance_steamid) == 1):
		stats.registerPlayer(steamid, instance_alias)
	
	rank 	= stats.getRank(steamid)
	points	= stats.getPoints(steamid)
	es.msg(instance_alias + '(Pos '+str(rank)+' with '+str(points)+' points) connected.')


def player_death(e):	
	# ============================== #
	
	raw_vict_steamid	= e['es_steamid']
	raw_attk_steamid	= e['es_attackersteamid']
	# == Victim Information == #
	env_vict_userid		= e['userid']
	env_vict_alias		= e['es_username']
	env_vict_steamid	= e['es_steamid']
	env_vict_team		= e['es_userteam']
	env_vict_steamid	= cst.getSteamId(env_vict_steamid, env_vict_alias)
	
	# == Attacker Information == #
	env_attk_userid		= e['attacker']
	env_attk_alias		= e['es_attackername']
	env_attk_steamid	= e['es_attackersteamid']
	env_attk_team		= e['es_attackerteam']
	env_attk_steamid	= cst.getSteamId(env_attk_steamid, env_attk_alias)
	
	# == Event / Misc Information == #
	env_var_weapon		= e['weapon']
	env_var_headshot	= e['headshot']
	
	# ============================== #
	
	# Register Death Points for Victim #
	if(cst.botCheck(raw_vict_steamid) == 1):
		stats.registerData(env_vict_steamid, 'deaths', 1)
	
	if(cst.botCheck(raw_attk_steamid) == 1):
		# register KillType #
		if(env_vict_steamid == env_attk_steamid):
			killType = 'suicide'
		else:
			if(env_vict_team == env_attk_team):
				killType = 'teamkill'
			else:
				killType = 'frag'
				
		# Proceed Registering Data #
		if(killType == 'suicide'):
			stats.registerData(env_attk_steamid, 'suicides', 1)
			
		if(killType == 'teamkill'):
			stats.registerData(env_attk_steamid, 'teamkills', 1)
			stats.removePoints(env_attk_steamid, cs_stats_teamkill_loss)
			es.tell(env_attk_userid, 'You lost -' + str(cs_stats_teamkill_loss)+ ' points for killing your teammate, '+str(env_vict_alias)+'.')
		
		if(killType == 'frag'):
			stats.registerData(env_attk_steamid, 'kills', 1)
			if(env_var_headshot == '1'):
				stats.registerData(env_attk_steamid, 'headshots', 1)
			pt_attk = stats.getPoints(env_attk_steamid)
			pt_vict = stats.getPoints(env_vict_steamid)
			if(pt_attk == 0):
				pt_attk = 2
			if(pt_vict == 0):
				pt_vict = 2
				
			p_delta = float(float(pt_vict) / float(pt_attk))
			p_delta = int(float(p_delta) * cs_stats_multiplier)
			if(p_delta < 2):
				p_delta = 2
			if(env_var_headshot == '1'):
				p_delta = p_delta + cs_stats_headshotbonus
			
			p_weapon_mod = stats.calcWeaponBonus(env_var_weapon)
			
			if(p_weapon_mod == 0):
				p_weapon_mod = 1
			p_delta = p_delta * p_weapon_mod
			if(p_delta > cs_stats_maxpoints):
				p_delta = cs_stats_maxpoints
			
			stats.registerData(env_attk_steamid, 'points', p_delta)
			es.tell(env_attk_userid, str(env_attk_alias) + ' received ' + str(p_delta) + ' points for killing ' + str(env_vict_alias) + ' with a ' +str(env_var_weapon)+ '.')
			es.tell(env_vict_userid, str(env_attk_alias) + ' received ' + str(p_delta) + ' points for killing ' + str(env_vict_alias) + ' with a ' +str(env_var_weapon)+ '.')

	# Register Points Removal for Victim #
	if(cst.botCheck(raw_vict_steamid) == 1):
		if(killType == 'frag'):
			pt_attk = stats.getPoints(env_attk_steamid)
			pt_vict = stats.getPoints(env_vict_steamid)
			if(pt_attk == 0):
				pt_attk = 2
			if(pt_vict == 0):
				pt_vict = 2
				
			p_delta = float(float(pt_attk) / float(pt_vict))
			p_delta = p_delta * 2
			if(p_delta > 15):
				p_delta = 15
			if(p_delta < 2):
				p_delta = 2
			p_weapon_mod = stats.calcWeaponBonus(env_var_weapon)
			p_delta = int(p_delta + p_weapon_mod)
			stats.removePoints(env_vict_steamid, p_delta)
			
	stats.syncRankTable()		
# ================================================================================== #
# ==============  R o u n d   S p e c i f i c   P o i n t  F u n c.  =============== #
# ================================================================================== #
def bomb_planted(e):
	env_user_steamid	= cst.getSteamId(e['es_steamid'], e['es_username'])
	env_user_alias		= e['es_username']
	env_user_userid		= e['userid']
	if(cst.botCheck(e['es_steamid']) == 1):
		points = cs_points_bomb_planted
		msgOut = str(env_user_alias) + ' got ' + str(points) + ' points for ' + str(cs_txt_objective_bomb_planted)
		es.tell(env_user_userid, msgOut)
		stats.registerData(env_user_steamid, 'points', points)
		stats.registerData(env_user_steamid, 'bombs_planted', 1)

def bomb_defused(e):
	env_user_steamid	= cst.getSteamId(e['es_steamid'], e['es_username'])
	env_user_alias		= e['es_username']
	env_user_userid		= e['userid']
	if(cst.botCheck(e['es_steamid']) == 1):
		points = cs_points_bomb_defused
		msgOut = str(env_user_alias) + ' got ' + str(points) + ' points for ' + str(cs_txt_objective_bomb_defused2)
		es.tell(env_user_userid, msgOut)
		stats.registerData(env_user_steamid, 'points', points)
		stats.registerData(env_user_steamid, 'bombs_defused', 1)		

def hostage_rescued(e):
	env_user_steamid	= cst.getSteamId(e['es_steamid'], e['es_username'])
	env_user_alias		= e['es_username']
	env_user_userid		= e['userid']
	if(cst.botCheck(e['es_steamid']) == 1):
		points = cs_points_hostage_resc
		msgOut = str(env_user_alias) + ' got ' + str(points) + ' points for ' + str(cs_txt_objective_hostage_resc)
		es.tell(env_user_userid, msgOut)
		stats.registerData(env_user_steamid, 'points', points)
		stats.registerData(env_user_steamid, 'hostages_rescued', 1)		


def hostage_killed(e):
	env_user_steamid	= cst.getSteamId(e['es_steamid'], e['es_username'])
	env_user_alias		= e['es_username']
	env_user_userid		= e['userid']
	if(cst.botCheck(e['es_steamid']) == 1):
		points = cs_points_hostage_kill
		msgOut = str(env_user_alias) + ' lost -' + str(points) + ' points for ' + str(cs_txt_objective_hostage_kill)
		es.tell(env_user_userid, msgOut)
		stats.removePoints(env_user_steamid, points)
		stats.registerData(env_user_steamid, 'hostages_killed', 1)		

		
	
def round_end(e):
	env_reason = e['reason']
		
	if(env_reason == '8'):
		# Terrorists Eliminated #
		msgOut = 'The Counter-Terrorists got '+str(cs_points_team_t_elim)+' points for ' + str(cs_txt_objective_t_eliminated)
		es.msg('#Multi', msgOut)
		stats.addTeamPoints('#ct', cs_points_team_t_elim)
	
	if(env_reason == '9'):
		# Counter-Terrorists Eliminated #
		msgOut = 'The Terrorists got '+str(cs_points_team_ct_elim)+' points for ' + str(cs_txt_objective_ct_eliminated)
		es.msg('#Multi', msgOut)
		stats.addTeamPoints('#ct', cs_points_team_ct_elim)

	if(env_reason == '1'):
		# Target Bombed #
		msgOut = 'The Terrorists got '+str(cs_points_team_bomb_bt)+' points for ' + str(cs_txt_objective_target_bombed)
		es.msg('#Multi', msgOut)
		stats.addTeamPoints('#ct', cs_points_team_bomb_bt)
		
	if(env_reason == '7'):
		# Bomb Defused #
		msgOut = 'The Counter-Terrorists got '+str(cs_points_team_bomb_d)+' points for ' + str(cs_txt_objective_bomb_defused)
		es.msg('#Multi', msgOut)
		stats.addTeamPoints('#ct', cs_points_team_bomb_d)
		
	if(env_reason == '11'):
		# Hostages Rescued #
		msgOut = 'The Counter-Terrorists got '+str(cs_points_team_hostage_r)+' points for ' + str(cs_txt_objective_hostage_r)
		es.msg('#Multi', msgOut)
		stats.addTeamPoints('#ct', cs_points_team_hostage_r)
		
	if(env_reason == '13'):
		# Hostages not Rescued #
		msgOut = 'The Terrorists got '+str(cs_points_team_hostage_k)+' points for ' + str(cs_txt_objective_hostage_nr)
		es.msg('#Multi', msgOut)
		stats.addTeamPoints('#ct', cs_points_team_hostage_k)
		
# ================================================================================== #
# =================== A d d o n   C l a s s e s   L i b r a r y ==================== #
# ================================================================================== #
class stats(object):
	
	def syncRankTable(self):
		global sql_conn
		q = sql_c.cursor()
		q.execute('SELECT * FROM stats ORDER BY points DESC')
		numrows = int(q.rowcount)
		for x in range(0, numrows):
			thisData = q.fetchone()
			steamid = thisData[0]
			st = str(x + 1)
			d = sql_c.cursor()
			d.execute('UPDATE stats SET rank="'+str(st)+'" WHERE steamid="'+steamid+'"')
			
	def addTeamPoints(self, team, points):
		c = sql_c.cursor()
		players = playerlib.getPlayerList(str(team))
		for player in players:
			userid = player.userid
			steamid = es.getplayersteamid(userid)
			c.execute('UPDATE stats SET points=points+"'+str(points)+'" WHERE steamid="'+str(steamid)+'"')
		
	def registerData(self, steamid, dataType, addValue):
		q = sql_c.cursor()
		q.execute('UPDATE stats SET '+str(dataType)+'='+str(dataType)+'+"'+str(addValue)+'"  WHERE steamid="'+str(steamid)+'"')

	def removePoints(self, steamid, amount):
		q = sql_c.cursor()
		q.execute('SELECT * FROM stats WHERE steamid="'+str(steamid)+'"')
		try:
			data   = q.fetchone()
			points = data[4]
		except:
			points = 0
		points = points - int(amount)
		q.execute('UPDATE stats SET points="'+str(points)+'" WHERE steamid="'+str(steamid)+'"')
	
	def getTotalRanks(self):
		q = sql_c.cursor()
		q.execute('SELECT * FROM stats')
		r = int(q.rowcount)
		return r
	
	def getPoints(self, steamid):
		q = sql_c.cursor()
		q.execute('SELECT * FROM stats WHERE steamid="'+str(steamid)+'"')
		try:
			data   = q.fetchone()
			points = data[4]
		except:
			points = 0
		return points
	def getRank(self, steamid):
		q = sql_c.cursor()
		q.execute('SELECT * FROM stats WHERE steamid="'+str(steamid)+'"')
		try:
			data   = q.fetchone()
			rank   = data[2]
		except:
			rank = '-'
		if(rank == 0):
			rank = '-'
		return rank
	
	def getData(self, steamid):
		q = sql_c.cursor()
		q.execute('SELECT * FROM stats WHERE steamid="'+str(steamid)+'"')
		n = int(q.rowcount)
		if(n < 1):
			data = '-1'
		else:
			data = q.fetchone()
		return data
				
	def registerPlayer(self, steamid, alias):
		q = sql_c.cursor()
		q.execute('SELECT * FROM stats WHERE steamid="'+str(steamid)+'"')
		numrows = int(q.rowcount)
		if(numrows > 0):
			try:
				data = q.fetchone()
				rank		= data[2]
				points		= data[4]
				kills		= data[6]
				deaths		= data[8]
				headshots	= data[10]
				c = sql_c.cursor()
				c.execute('UPDATE stats SET rank_old="'+str(rank)+'",points_old="'+str(points)+'",kills_old="'+str(kills)+'",deaths_old="'+str(deaths)+'",headshots_old="'+str(headshots)+'" WHERE steamid="'+str(steamid)+'"')
			except:
				cst.log('Could not update stats for player: ' + str(alias) + '.')
		else:
			c = sql_c.cursor()
			c.execute('INSERT INTO stats (steamid, playername)VALUES("'+str(steamid)+'","'+str(alias)+'")')

	def calcWeaponBonus(self,weapon):
		weapon_bonus = 1
		if(weapon=='glock'):
			weapon_bonus = cs_bonus_weapon_glock
		if(weapon=='usp'):
			weapon_bonus = cs_bonus_weapon_usp
		if(weapon=='p228'):
			weapon_bonus = cs_bonus_weapon_p228
		if(weapon=='deagle'):
			weapon_bonus = cs_bonus_weapon_deagle
		if(weapon=='fiveseven'):
			weapon_bonus = cs_bonus_weapon_fiveseven
		if(weapon=='elite'):
			weapon_bonus = cs_bonus_weapon_elite
		if(weapon=='m3'):
			weapon_bonus = cs_bonus_weapon_m3
		if(weapon=='xm1014'):
			weapon_bonus = cs_bonus_weapon_xm1014
		if(weapon=='tmp'):
			weapon_bonus = cs_bonus_weapon_tmp
		if(weapon=='mac10'):
			weapon_bonus = cs_bonus_weapon_mac10
		if(weapon=='mp5navy'):
			weapon_bonus = cs_bonus_weapon_mp5navy
		if(weapon=='ump45'):
			weapon_bonus = cs_bonus_weapon_ump45
		if(weapon=='p90'):
			weapon_bonus = cs_bonus_weapon_p90
		if(weapon=='famas'):
			weapon_bonus = cs_bonus_weapon_famas
		if(weapon=='galil'):
			weapon_bonus = cs_bonus_weapon_galil
		if(weapon=='ak47'):
			weapon_bonus = cs_bonus_weapon_ak47
		if(weapon=='scout'):
			weapon_bonus = cs_bonus_weapon_scout
		if(weapon=='m4a1'):
			weapon_bonus = cs_bonus_weapon_m4a1
		if(weapon=='sg550'):
			weapon_bonus = cs_bonus_weapon_sg550
		if(weapon=='g3sg1'):
			weapon_bonus = cs_bonus_weapon_g3sg1
		if(weapon=='awp'):
			weapon_bonus = cs_bonus_weapon_awp
		if(weapon=='sg552'):
			weapon_bonus = cs_bonus_weapon_sg552
		if(weapon=='aug'):
			weapon_bonus = cs_bonus_weapon_aug
		if(weapon=='m249'):
			weapon_bonus = cs_bonus_weapon_m249
		if(weapon=='hegrenade'):
			weapon_bonus = cs_bonus_weapon_hegrenade
		if(weapon=='flashbang'):
			weapon_bonus = cs_bonus_weapon_flashbang
		if(weapon=='smokegrenade'):
			weapon_bonus = cs_bonus_weapon_smokegrenade
		if(weapon=='knife'):
			weapon_bonus = cs_bonus_weapon_knife
		return weapon_bonus
				
stats = stats()

class cst(object):
	def init(self):
		self.log('--------------------------------------------------------------------')
		self.log('-- cSTATS - Ranks & Statistics Modification for CS:Source Servers --')
		self.log('--------------------------------------------------------------------')
		self.mysql_connect()
		self.mysql_createTableEntry()
		self.log('--------------------------------------------------------------------')
	def log(self, msg):
		es.dbgmsg(0, msg);
		
	def mysql_connect(self):
		global sql_c
		self.log('Attempting to connect to [' + str(cs_mysql_hostname)+ ']...')
		try:
			sql_c = MySQLdb.connect(cs_mysql_hostname, cs_mysql_username, cs_mysql_password, cs_mysql_database)
			if(sql_c):
				self.log('Successfully connected to '+str(cs_mysql_hostname)+' with username "'+str(cs_mysql_username)+'".')
				
		except MySQLdb.Error, e:
			self.log('ERROR: Could not connect to the MySQL Server!')
			self.log('ERROR: ' + str(e))
			es.unload(info.basename)
			return
	
	def mysql_createTableEntry(self):
		try:
			table = "CREATE TABLE IF NOT EXISTS `stats` (`steamid` VARCHAR( 255 ) NOT NULL ,`playername` VARCHAR( 255 ) NOT NULL ,`rank` INT( 11 ) NOT NULL DEFAULT '0',`rank_old` INT( 11 ) NOT NULL DEFAULT '0',`points` INT( 11 ) NOT NULL DEFAULT '0',`points_old` INT( 11 ) NOT NULL DEFAULT '0',`kills` INT( 11 ) NOT NULL DEFAULT '0',`kills_old` INT( 11 ) NOT NULL DEFAULT '0',`deaths` INT( 11 ) NOT NULL DEFAULT '0',`deaths_old` INT( 11 ) NOT NULL DEFAULT '0',`headshots` INT( 11 ) NOT NULL DEFAULT '0',`headshots_old` INT( 11 ) NOT NULL DEFAULT '0',`bombs_planted` INT( 11 ) NOT NULL DEFAULT '0',`bombs_defused` INT( 11 ) NOT NULL DEFAULT '0',`hostages_rescued` INT( 11 ) NOT NULL DEFAULT '0',`hostages_killed` INT( 11 ) NOT NULL DEFAULT '0',`suicides` INT( 11 ) NOT NULL DEFAULT '0',`teamkills` INT( 11 ) NOT NULL DEFAULT '0',PRIMARY KEY ( `steamid` ) ) ENGINE = MYISAM"
			q = sql_c.cursor()
			q.execute(table)
			self.log('Added Statistics Table to database. (Ignore the warning above if there is one)')
		except:
			self.log('---')

	def botCheck(self, steamid):
		global cs_include_bots
		if(steamid == "BOT"):
			if(cs_include_bots == 1):
				return 1
			else:
				return 0
		else:
			return 1
	
	def getSteamId(self, steamid, alias):
		if(steamid == "BOT"):
			steamid = "BOT:" + str(alias)
			return steamid
		else:
			return steamid

cst = cst()	
# ================================================================================== #
